diff -N -U 5 -u openssh-4.2p1/readconf.c sshop-4.2p1/readconf.c
--- openssh-4.2p1/readconf.c	Fri Aug 12 08:11:18 2005
+++ sshop-4.2p1/readconf.c	Fri Oct 21 16:02:29 2005
@@ -105,10 +105,11 @@
 	oClearAllForwardings, oNoHostAuthenticationForLocalhost,
 	oEnableSSHKeysign, oRekeyLimit, oVerifyHostKeyDNS, oConnectTimeout,
 	oAddressFamily, oGssAuthentication, oGssDelegateCreds,
 	oServerAliveInterval, oServerAliveCountMax, oIdentitiesOnly,
 	oSendEnv, oControlPath, oControlMaster, oHashKnownHosts,
+	oPrivateLocalForward, oUnixDomainSocket,
 	oDeprecated, oUnsupported
 } OpCodes;
 
 /* Textual representations of the tokens. */
 
@@ -196,10 +197,12 @@
 	{ "serveralivecountmax", oServerAliveCountMax },
 	{ "sendenv", oSendEnv },
 	{ "controlpath", oControlPath },
 	{ "controlmaster", oControlMaster },
 	{ "hashknownhosts", oHashKnownHosts },
+	{ "privatelocalforward", oPrivateLocalForward },
+	{ "unixdomainsocket", oUnixDomainSocket },
 	{ NULL, oBadOption }
 };
 
 /*
  * Adds a local TCP/IP port forward to options.  Never returns if there is an
@@ -210,11 +213,12 @@
 add_local_forward(Options *options, const Forward *newfwd)
 {
 	Forward *fwd;
 #ifndef NO_IPPORT_RESERVED_CONCEPT
 	extern uid_t original_real_uid;
-	if (newfwd->listen_port < IPPORT_RESERVED && original_real_uid != 0)
+	if ((newfwd->listen_port > 0) &&
+	    (newfwd->listen_port < IPPORT_RESERVED) && original_real_uid != 0)
 		fatal("Privileged ports can only be forwarded by root.");
 #endif
 	if (options->num_local_forwards >= SSH_MAX_FORWARDS_PER_DIRECTION)
 		fatal("Too many local forwards (max %d).", SSH_MAX_FORWARDS_PER_DIRECTION);
 	fwd = &options->local_forwards[options->num_local_forwards++];
@@ -294,10 +298,13 @@
 process_config_line(Options *options, const char *host,
 		    char *line, const char *filename, int linenum,
 		    int *activep)
 {
 	char *s, **charptr, *endofnumber, *keyword, *arg, *arg2, fwdarg[256];
+	u_short fwd_host_port;
+	char sfwd_host_port[6];
+	char sfwd_uds_path[1024];
 	int opcode, *intptr, value;
 	size_t len;
 	Forward fwd;
 
 	/* Strip trailing whitespace */
@@ -702,10 +709,34 @@
 			    filename, linenum);
 		if (*activep)
 			add_local_forward(options, &fwd);
 		break;
 
+	case oPrivateLocalForward:
+		arg = strdelim(&s);
+		memset(&fwd, '\0', sizeof(fwd));
+		/* parse the input */
+		if (sscanf(arg, "%1023[^,],%255[^,],%5[0123456789]",
+		    sfwd_uds_path, fwdarg, sfwd_host_port) < 3) {
+			fatal("%.200s line %d: Bad domain socket specification.",
+			    filename, linenum);
+		}
+
+		/* check the port info */
+		if ((fwd_host_port = a2port(sfwd_host_port)) == 0) {
+			fatal("%.200s line %d: Remote port not defined.",
+			    filename, linenum);
+		}
+		fwd.listen_host  = xstrdup(sfwd_uds_path);
+		fwd.listen_port  = 0;
+		fwd.connect_host = xstrdup(fwdarg);
+		fwd.connect_host = cleanhostname(fwd.connect_host);
+		fwd.connect_port = fwd_host_port;
+		if (*activep)
+			add_local_forward(options, &fwd);
+		break;
+
 	case oClearAllForwardings:
 		intptr = &options->clear_forwardings;
 		goto parse_flag;
 
 	case oHost:
@@ -820,10 +851,14 @@
 
 	case oHashKnownHosts:
 		intptr = &options->hash_known_hosts;
 		goto parse_flag;
 
+	case oUnixDomainSocket:
+		charptr = &options->uds_path;
+		goto parse_string;
+
 	case oDeprecated:
 		debug("%s line %d: Deprecated option \"%s\"",
 		    filename, linenum, keyword);
 		return 0;
 
@@ -964,10 +999,11 @@
 	options->server_alive_count_max = -1;
 	options->num_send_env = 0;
 	options->control_path = NULL;
 	options->control_master = -1;
 	options->hash_known_hosts = -1;
+	options->uds_path = NULL;
 }
 
 /*
  * Called after processing other sources of option data, this fills those
  * options for which no value has been specified with their default values.
@@ -1093,10 +1129,11 @@
 	/* options->proxy_command should not be set by default */
 	/* options->user will be set in the main program if appropriate */
 	/* options->hostname will be set in the main program if appropriate */
 	/* options->host_key_alias should not be set by default */
 	/* options->preferred_authentications will be set in ssh */
+	/* options->uds_path should not be set by default */
 }
 
 /*
  * parse_forward
  * parses a string containing a port forwarding specification of the form:
diff -N -U 5 -u openssh-4.2p1/readconf.h sshop-4.2p1/readconf.h
--- openssh-4.2p1/readconf.h	Wed Jun 15 23:19:42 2005
+++ sshop-4.2p1/readconf.h	Fri Oct 21 16:02:29 2005
@@ -20,11 +20,12 @@
 
 /* Data structure for representing a forwarding request. */
 
 typedef struct {
 	char	 *listen_host;		/* Host (address) to listen on. */
-	u_short	  listen_port;		/* Port to forward. */
+	u_short	  listen_port;		/* Port to forward.  if 0, listen_host
+					 * is a unix domain socket. */
 	char	 *connect_host;		/* Host to connect. */
 	u_short	  connect_port;		/* Port to connect on connect_host. */
 }       Forward;
 /* Data structure for representing option data. */
 
@@ -112,10 +113,13 @@
 
 	char	*control_path;
 	int	control_master;
 
 	int	hash_known_hosts;
+
+	char	*uds_path;	/* Path for unix domain socket to connect to
+				 * (used in place of port). */
 }       Options;
 
 #define SSHCTL_MASTER_NO	0
 #define SSHCTL_MASTER_YES	1
 #define SSHCTL_MASTER_AUTO	2
diff -N -U 5 -u openssh-4.2p1/readpass.c sshop-4.2p1/readpass.c
--- openssh-4.2p1/readpass.c	Wed May 25 22:07:48 2005
+++ sshop-4.2p1/readpass.c	Fri Oct 21 16:02:29 2005
@@ -89,20 +89,76 @@
 	memset(buf, 0, sizeof(buf));
 	return pass;
 }
 
 /*
+ * Function to prepend the process id to every line in a prompt.
+ */
+void
+add_id_to_prompt(const char *prompt, char *newprompt, int newprompt_size)
+{
+	char  *np;
+	const char *p = prompt;
+	int  len, cnt;
+	int  pid = getpid();
+
+	if (newprompt == NULL)
+		return;
+
+	np = newprompt;
+	len = newprompt_size;
+
+	while (p != NULL) {
+		cnt = snprintf(np, len, "[%d] ", pid);
+
+		/* Able to write the entire label */
+		if (cnt < len) {
+			len -= cnt;
+			np  += cnt;
+		/* Out of space */
+		}  else {
+			np += len;
+			len = 0;
+		}
+		/* Copy characters until out of space, or an
+		* EOL or newline is found.
+		*/
+		for (; *p != '\0' && *p != '\n' && len > 0;
+		   p++, np++, len--) {
+			*np = *p;
+		}
+		/* Out of space */
+		if (len == 0) {
+			*(np-1) = '\0';
+			p = NULL;
+		/* Copy the EOL or newline. */
+		} else {
+			*np = *p;
+			/* EOL, terminate the loop */
+			if (*p == '\0') {
+				p = NULL;
+			/* Otherwise, move to next character */
+			} else {
+				p++;
+				np++;
+			}
+		}
+	}
+}
+
+/*
  * Reads a passphrase from /dev/tty with echo turned off/on.  Returns the
  * passphrase (allocated with xmalloc).  Exits if EOF is encountered. If
  * RP_ALLOW_STDIN is set, the passphrase will be read from stdin if no
  * tty is available
  */
 char *
 read_passphrase(const char *prompt, int flags)
 {
 	char *askpass = NULL, *ret, buf[1024];
-	int rppflags, use_askpass = 0, ttyfd;
+	int rppflags, use_askpass = 0, ttyfd, len;
+	char newprompt[1024];
 
 	rppflags = (flags & RP_ECHO) ? RPP_ECHO_ON : RPP_ECHO_OFF;
 	if (flags & RP_USE_ASKPASS)
 		use_askpass = 1;
 	else if (flags & RP_ALLOW_STDIN) {
@@ -119,26 +175,35 @@
 			debug("read_passphrase: can't open %s: %s", _PATH_TTY,
 			    strerror(errno));
 			use_askpass = 1;
 		}
 	}
+	/* Prepend the process id to each line in the prompt */
+	if ((flags & RP_ADD_ID)) {
+		add_id_to_prompt(prompt, newprompt, sizeof(newprompt));
+	/* Nothing to be added to the prompt, use the original */
+	} else {
+		len = sizeof(newprompt);
+		strncpy(newprompt, prompt, len);
+		newprompt[len-1] = '\0';
+	}
 
 	if ((flags & RP_USE_ASKPASS) && getenv("DISPLAY") == NULL)
 		return (flags & RP_ALLOW_EOF) ? NULL : xstrdup("");
 
 	if (use_askpass && getenv("DISPLAY")) {
 		if (getenv(SSH_ASKPASS_ENV))
 			askpass = getenv(SSH_ASKPASS_ENV);
 		else
 			askpass = _PATH_SSH_ASKPASS_DEFAULT;
-		if ((ret = ssh_askpass(askpass, prompt)) == NULL)
+		if ((ret = ssh_askpass(askpass, newprompt)) == NULL)
 			if (!(flags & RP_ALLOW_EOF))
 				return xstrdup("");
 		return ret;
 	}
 
-	if (readpassphrase(prompt, buf, sizeof buf, rppflags) == NULL) {
+	if (readpassphrase(newprompt, buf, sizeof buf, rppflags) == NULL) {
 		if (flags & RP_ALLOW_EOF)
 			return NULL;
 		return xstrdup("");
 	}
 
Common subdirectories: openssh-4.2p1/regress and sshop-4.2p1/regress
Common subdirectories: openssh-4.2p1/scard and sshop-4.2p1/scard
diff -N -U 5 -u openssh-4.2p1/scard.c sshop-4.2p1/scard.c
--- openssh-4.2p1/scard.c	Thu May 13 02:15:48 2004
+++ sshop-4.2p1/scard.c	Wed May 11 17:54:01 2005
@@ -429,11 +429,11 @@
 static int
 get_AUT0(u_char *aut0)
 {
 	char *pass;
 
-	pass = read_passphrase("Enter passphrase for smartcard: ", RP_ALLOW_STDIN);
+	pass = read_passphrase("Enter passphrase for smartcard: ", RP_ALLOW_STDIN|RP_ADD_ID);
 	if (pass == NULL)
 		return -1;
 	if (!strcmp(pass, "-")) {
 		memcpy(aut0, DEFAUT0, sizeof DEFAUT0);
 		return 0;
diff -N -U 5 -u openssh-4.2p1/ssh.c sshop-4.2p1/ssh.c
--- openssh-4.2p1/ssh.c	Fri Aug 12 08:10:56 2005
+++ sshop-4.2p1/ssh.c	Fri Oct 21 16:02:31 2005
@@ -70,180 +70,147 @@
 #include "sshpty.h"
 #include "match.h"
 #include "msg.h"
 #include "monitor_fdpass.h"
 #include "uidswap.h"
+#include "sshhop.h"
 
 #ifdef SMARTCARD
 #include "scard.h"
 #endif
 
 extern char *__progname;
 
-/* Flag indicating whether debug mode is on.  This can be set on the command line. */
+/* Flag indicating whether debug mode is on.  This can be set on the
+ * command line. This variable is exported (global).
+ */
 int debug_flag = 0;
 
 /* Flag indicating whether a tty should be allocated */
-int tty_flag = 0;
-int no_tty_flag = 0;
-int force_tty_flag = 0;
+static int tty_flag = 0;
+static int no_tty_flag = 0;
+static int force_tty_flag = 0;
 
-/* don't exec a shell */
+/* don't exec a shell. This is an exported variable (global). */
 int no_shell_flag = 0;
 
 /*
  * Flag indicating that nothing should be read from stdin.  This can be set
- * on the command line.
+ * on the command line. This variable is exported (global).
  */
 int stdin_null_flag = 0;
 
 /*
  * Flag indicating that ssh should fork after authentication.  This is useful
  * so that the passphrase can be entered manually, and then ssh goes to the
  * background.
  */
-int fork_after_authentication_flag = 0;
+static int fork_after_authentication_flag = 0;
 
 /*
  * General data structure for command line options and options configurable
- * in configuration files.  See readconf.h.
+ * in configuration files.  See readconf.h. This variable is exported
+ * (global).
  */
 Options options;
 
 /* optional user configfile */
-char *config = NULL;
+static char *config = NULL;
 
 /*
  * Name of the host we are connecting to.  This is the name given on the
  * command line, or the HostName specified for the user-supplied name in a
- * configuration file.
+ * configuration file. This variable is exported (global).
  */
 char *host;
 
 /* socket address the host resolves to */
-struct sockaddr_storage hostaddr;
+static struct sockaddr_storage hostaddr;
 
 /* Private host keys. */
-Sensitive sensitive_data;
+static Sensitive sensitive_data;
 
-/* Original real UID. */
+/* Original real UID. These variables are exported (global) */
 uid_t original_real_uid;
 uid_t original_effective_uid;
 
 /* command to be executed */
-Buffer command;
+static Buffer command;
 
 /* Should we execute a command or invoke a subsystem? */
-int subsystem_flag = 0;
+static int subsystem_flag = 0;
 
 /* # of replies received for global requests */
 static int client_global_request_id = 0;
 
-/* pid of proxycommand child process */
+/* pid of proxycommand child process. This variable is exported (global) */
 pid_t proxy_command_pid = 0;
 
-/* fd to control socket */
+/* fd to control socket. This variable is exported (global). */
 int control_fd = -1;
 
 /* Multiplexing control command */
 static u_int mux_command = 0;
 
 /* Only used in control client mode */
 volatile sig_atomic_t control_client_terminate = 0;
-u_int control_server_pid = 0;
+static u_int control_server_pid = 0;
 
 /* Prints a help message to the user.  This function never returns. */
-
 static void
 usage(void)
 {
 	fprintf(stderr,
+	/* Standard SSH command line syntax */
 "usage: ssh [-1246AaCfgkMNnqsTtVvXxY] [-b bind_address] [-c cipher_spec]\n"
 "           [-D port] [-e escape_char] [-F configfile]\n"
 "           [-i identity_file] [-L [bind_address:]port:host:hostport]\n"
 "           [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port]\n"
 "           [-R [bind_address:]port:host:hostport] [-S ctl_path]\n"
 "           [user@]hostname [command]\n"
+"    or\n"
+	/* SSH hop command line syntax.
+	 * Command line syntax for automatically creating a chain of SSH
+	 * processes to securely SSH from this host to the destination host
+	 * through intermediary hosts. Each host in this chain represents a
+	 * single "hop". The authentication credentials are only revealed
+	 * at this host and at the host for which those credentials are
+	 * intended.
+	 */
+"       ssh [ssh_options] -H [ssh_options] [-p port1] [user1@]host1\n"
+"                     ... -H [ssh_options] [-p portn] [usern@]hostn\n"
+"           [command]\n"
 	);
 	exit(1);
 }
 
 static int ssh_session(void);
 static int ssh_session2(void);
 static void load_public_identity_files(void);
 static void control_client(const char *path);
 
-/*
- * Main program for the ssh client.
- */
 int
-main(int ac, char **av)
+parse_options(int ac, char **av)
 {
-	int i, opt, exit_status;
+	int opt;
+	u_short fwd_host_port;
+	char sfwd_host_port[6];
+	char sfwd_uds_path[1024];
 	char *p, *cp, *line, buf[256];
 	struct stat st;
-	struct passwd *pw;
 	int dummy;
 	extern int optind, optreset;
 	extern char *optarg;
-	struct servent *sp;
 	Forward fwd;
-
-	__progname = ssh_get_progname(av[0]);
-	init_rng();
-
-	/*
-	 * Save the original real uid.  It will be needed later (uid-swapping
-	 * may clobber the real uid).
-	 */
-	original_real_uid = getuid();
-	original_effective_uid = geteuid();
-
-	/*
-	 * Use uid-swapping to give up root privileges for the duration of
-	 * option processing.  We will re-instantiate the rights when we are
-	 * ready to create the privileged port, and will permanently drop
-	 * them when the port has been created (actually, when the connection
-	 * has been made, as we may need to create the port several times).
-	 */
-	PRIV_END;
-
-#ifdef HAVE_SETRLIMIT
-	/* If we are installed setuid root be careful to not drop core. */
-	if (original_real_uid != original_effective_uid) {
-		struct rlimit rlim;
-		rlim.rlim_cur = rlim.rlim_max = 0;
-		if (setrlimit(RLIMIT_CORE, &rlim) < 0)
-			fatal("setrlimit failed: %.100s", strerror(errno));
-	}
-#endif
-	/* Get user data. */
-	pw = getpwuid(original_real_uid);
-	if (!pw) {
-		logit("You don't exist, go away!");
-		exit(1);
-	}
-	/* Take a copy of the returned structure. */
-	pw = pwcopy(pw);
-
-	/*
-	 * Set our umask to something reasonable, as some files are created
-	 * with the default umask.  This will make them world-readable but
-	 * writable only by the owner, which is ok for all files for which we
-	 * don't set the modes explicitly.
-	 */
-	umask(022);
-
-	/* Initialize option structure to indicate that no values have been set. */
-	initialize_options(&options);
+	optind = 1;
+	optreset = 1;
 
 	/* Parse command-line arguments. */
 	host = NULL;
 
 again:
-	while ((opt = getopt(ac, av,
-	    "1246ab:c:e:fgi:kl:m:no:p:qstvxACD:F:I:L:MNO:PR:S:TVXY")) != -1) {
+	while ((opt = getopt(ac, av, SSH_CMDLINE_OPTIONS)) != -1) {
 		switch (opt) {
 		case '1':
 			options.protocol = SSH_PROTO_1;
 			break;
 		case '2':
@@ -481,10 +448,41 @@
 			options.bind_address = optarg;
 			break;
 		case 'F':
 			config = optarg;
 			break;
+		case 'u':
+			if (options.uds_path != NULL) {
+				free(options.uds_path);
+			}
+			options.uds_path = xstrdup(optarg);
+			break;
+		case 'U':
+			memset(&fwd, '\0', sizeof(fwd));
+			/* parse the input */
+			if (sscanf(optarg, "%1023[^,],%255[^,],%5[0123456789]",
+			    sfwd_uds_path, buf, sfwd_host_port) < 3) {
+				fprintf(stderr,
+				    "Bad domain socket specification '%s'\n",
+				    optarg);
+				usage();
+				/* NOTREACHED */
+			}
+
+			/* check the port info */
+			if ((fwd_host_port = a2port(sfwd_host_port)) == 0) {
+				fprintf(stderr,
+				    "Remote port not defined.\n");
+				usage();
+			}
+			fwd.listen_host  = xstrdup(sfwd_uds_path);
+			fwd.listen_port  = 0;
+			fwd.connect_host = xstrdup(buf);
+			fwd.connect_host = cleanhostname(fwd.connect_host);
+			fwd.connect_port = fwd_host_port;
+			add_local_forward(&options, &fwd);
+			break;
 		default:
 			usage();
 		}
 	}
 
@@ -511,10 +509,146 @@
 
 	/* Check that we got a host name. */
 	if (!host)
 		usage();
 
+	/* Check for consistency between uds_path and host name */
+	if (options.uds_path != NULL && strcmp(host, "localhost") != 0) {
+		char hostname[MAXHOSTNAMELEN];
+		memset(hostname, '\0', sizeof(hostname));
+		if (gethostname(hostname, sizeof(hostname)) != 0 ||
+		    strcmp(host, hostname) != 0) {
+			fprintf(stderr,
+			"Can't use Unix Domain Sockets on a remote host\n");
+			exit(1);
+		}
+	}
+	return(ac);
+}
+
+/*
+ * Main program for the ssh client.
+ */
+int
+main(int ac, char **av)
+{
+	int i, exit_status, hops;
+	char *p, *cp, buf[256];
+	struct stat st;
+	struct passwd *pw;
+	struct servent *sp;
+
+	__progname = ssh_get_progname(av[0]);
+	init_rng();
+
+	/*
+	 * Save the original real uid.  It will be needed later (uid-swapping
+	 * may clobber the real uid).
+	 */
+	original_real_uid = getuid();
+	original_effective_uid = geteuid();
+
+	/*
+	 * Use uid-swapping to give up root privileges for the duration of
+	 * option processing.  We will re-instantiate the rights when we are
+	 * ready to create the privileged port, and will permanently drop
+	 * them when the port has been created (actually, when the connection
+	 * has been made, as we may need to create the port several times).
+	 */
+	PRIV_END;
+
+#ifdef HAVE_SETRLIMIT
+	/* If we are installed setuid root be careful to not drop core. */
+	if (original_real_uid != original_effective_uid) {
+		struct rlimit rlim;
+		rlim.rlim_cur = rlim.rlim_max = 0;
+		if (setrlimit(RLIMIT_CORE, &rlim) < 0)
+			fatal("setrlimit failed: %.100s", strerror(errno));
+	}
+#endif
+	/* Get user data. */
+	pw = getpwuid(original_real_uid);
+	if (!pw) {
+		logit("You don't exist, go away!");
+		exit(1);
+	}
+	/* Take a copy of the returned structure. */
+	pw = pwcopy(pw);
+
+	/*
+	 * Set our umask to something reasonable, as some files are created
+	 * with the default umask.  This will make them world-readable but
+	 * writable only by the owner, which is ok for all files for which we
+	 * don't set the modes explicitly.
+	 */
+	umask(022);
+
+	/* Initialize option structure to indicate that no values have been set. */
+	initialize_options(&options);
+
+	/* Check for hops indicated with the -H option on the command line.
+	 * Each hop is a connection from this host to the next host in
+	 * the chain of hosts. The chain extends from this host to the
+	 * final destination through a string of intermediary hosts.
+	 */
+	hops = sshop_parse_options(ac, av, usage);
+
+	/* If either no -H options or only one -H option then no hopping
+	 * is needed. Free any memory allocated during hop processing and
+	 * then continue with the standard processing.
+	 */
+	if (hops <= 1) {
+		sshop_cleanup();
+		/* Continue below */
+	} else {
+	/*
+	 * Otherwise, multiple -H options (hops) indicated; process the hops.
+	 * Since a separate ssh process is invoked for each hop, we will
+	 * exit when hop processing is completed and not continue with the
+	 * standard ssh session processing.
+	 */
+		int error;
+		/*
+		 * Initialize "log" output.  Since we are the client, all output
+		 * actually goes to stderr.
+		 */
+		log_init(av[0],
+		    options.log_level == -1 ? SYSLOG_LEVEL_INFO : options.log_level,
+		    SYSLOG_FACILITY_USER, 1);
+
+		/* Make sure the user name is set for all hops */
+		sshop_set_default_user(pw->pw_name);
+
+		/* Build the chain of SSH subprocesses to implement the
+		 * secured connection from one host to another through
+		 * intermediate hosts. This involves processing command
+		 * line options and invoking SSH for each hop.
+		 * None of the processes in this chain are shared with other
+		 * hop chains. Thus, the processes will all need to be 
+		 * terminated when the session ends. */
+		error = sshop_build_chain(av[0]);
+
+		/* Hop chain established successfully, wait to clean up
+		 * intermediate processes when session is completed.
+		 */
+		if (error == 0) {
+			sshop_wait_for_exit();
+		} else {
+		/* The SSH subprocesses were not started properly, shut
+		 * everything down.
+		 */
+			sshop_kill_subprocesses();
+			sshop_wait_for_exit();
+		}
+		/* Make sure we don't fall into regular SSH processing */
+		exit(0);
+		/* Exit here */
+	}
+
+	/* Parse command-line arguments. */
+	ac = parse_options(ac, av);
+
 	SSLeay_add_all_algorithms();
 	ERR_load_crypto_strings();
 
 	/* Initialize the command to execute on remote host. */
 	buffer_init(&command);
@@ -614,10 +748,16 @@
 	}
 
 	if (options.proxy_command != NULL &&
 	    strcmp(options.proxy_command, "none") == 0)
 		options.proxy_command = NULL;
+
+	if (options.uds_path != NULL) {
+		options.uds_path = tilde_expand_filename(
+		   options.uds_path, original_real_uid);
+	}
+
 	if (options.control_path != NULL &&
 	    strcmp(options.control_path, "none") == 0)
 		options.control_path = NULL;
 
 	if (options.control_path != NULL) {
@@ -631,20 +771,28 @@
 	if (mux_command != 0 && options.control_path == NULL)
 		fatal("No ControlPath specified for \"-O\" command");
 	if (options.control_path != NULL)
 		control_client(options.control_path);
 
-	/* Open a connection to the remote host. */
-	if (ssh_connect(host, &hostaddr, options.port,
-	    options.address_family, options.connection_attempts,
+	/* Open a connection to the remote host. We need to use different
+	 * connection algorithms, depending on whether we are using regular
+	 * sockets or Unix Domain Sockets (UDS).
+	 */
+	if (options.uds_path == NULL) {
+	    if (ssh_connect(host, &hostaddr, options.port,
+	        options.address_family, options.connection_attempts,
 #ifdef HAVE_CYGWIN
-	    options.use_privileged_port,
+	        options.use_privileged_port,
 #else
-	    original_effective_uid == 0 && options.use_privileged_port,
+	        original_effective_uid == 0 && options.use_privileged_port,
 #endif
-	    options.proxy_command) != 0)
-		exit(1);
+	        options.proxy_command) != 0)
+		    exit(1);
+	} else {
+		if(ssh_connect_uds(options.uds_path, &hostaddr) != 0)
+			exit(1);
+	}
 
 	/*
 	 * If we successfully made the connection, load the host private key
 	 * in case we will need it later for combined rsa-rhosts
 	 * authentication. This must be done before releasing extra
diff -N -U 5 -u openssh-4.2p1/ssh.h sshop-4.2p1/ssh.h
--- openssh-4.2p1/ssh.h	Mon Dec  6 06:47:42 2004
+++ sshop-4.2p1/ssh.h	Tue May 10 14:36:17 2005
@@ -111,6 +111,7 @@
 #define SSH_RSA_MINIMUM_MODULUS_SIZE	768
 
 /* Listen backlog for sshd, ssh-agent and forwarding sockets */
 #define SSH_LISTEN_BACKLOG		128
 
+#define SSH_CMDLINE_OPTIONS	"1246ab:c:e:fgi:kl:m:no:p:qstu:vxACD:F:HI:L:MNO:PR:S:TU:VXY"
 #endif				/* SSH_H */
diff -N -U 5 -u openssh-4.2p1/sshconnect.c sshop-4.2p1/sshconnect.c
--- openssh-4.2p1/sshconnect.c	Sun Jul 17 03:22:46 2005
+++ sshop-4.2p1/sshconnect.c	Fri Oct 21 16:02:31 2005
@@ -383,10 +383,47 @@
 	packet_set_connection(sock, sock);
 
 	return 0;
 }
 
+int
+ssh_connect_uds(const char *uds_path, struct sockaddr_storage * hostaddr)
+{
+	struct sockaddr_un addr;
+	int sock, addr_len;
+
+	if (uds_path == NULL)
+		return -1;
+	else if (strlen(uds_path) == 0)
+		return -1;
+
+	memset(&addr, '\0', sizeof(addr));
+	addr.sun_family = AF_UNIX;
+	addr_len = offsetof(struct sockaddr_un, sun_path) +
+	    strlen(uds_path) + 1;
+
+	if (strlcpy(addr.sun_path, uds_path,
+	    sizeof(addr.sun_path)) >= sizeof(addr.sun_path))
+		fatal("Path for socket too long");
+
+	if ((sock = socket(PF_UNIX, SOCK_STREAM, 0)) < 0)
+		fatal("%s socket(): %s", __func__, strerror(errno));
+
+	/* Return failure if we didn't get a successful connection. */
+	if (connect(sock, (struct sockaddr*)&addr, addr_len) == -1) {
+		logit("ssh: Couldn't connect to %s: %s", uds_path,					strerror(errno));
+		return errno;
+	}
+
+	memcpy(hostaddr, (void *)&addr, addr_len);
+
+	/* Set the connection. */
+	packet_set_connection(sock, sock);
+
+	return 0;
+}
+
 /*
  * Waits for the server identification string, and sends our own
  * identification string.
  */
 static void
@@ -498,11 +535,11 @@
 	int ret = -1;
 
 	if (options.batch_mode)
 		return 0;
 	for (msg = prompt;;msg = again) {
-		p = read_passphrase(msg, RP_ECHO);
+		p = read_passphrase(msg, RP_ECHO|RP_ADD_ID);
 		if (p == NULL ||
 		    (p[0] == '\0') || (p[0] == '\n') ||
 		    strncasecmp(p, "no", 2) == 0)
 			ret = 0;
 		if (p && strncasecmp(p, "yes", 3) == 0)
@@ -543,10 +580,13 @@
 	 * essentially disables host authentication for localhost; however,
 	 * this is probably not a real problem.
 	 */
 	/**  hostaddr == 0! */
 	switch (hostaddr->sa_family) {
+	case AF_UNIX:
+		local = 1;
+		break;
 	case AF_INET:
 		local = (ntohl(((struct sockaddr_in *)hostaddr)->
 		    sin_addr.s_addr) >> 24) == IN_LOOPBACKNET;
 		salen = sizeof(struct sockaddr_in);
 		break;
@@ -570,14 +610,24 @@
 	/*
 	 * We don't have the remote ip-address for connections
 	 * using a proxy command
 	 */
 	if (options.proxy_command == NULL) {
-		if (getnameinfo(hostaddr, salen, ntop, sizeof(ntop),
-		    NULL, 0, NI_NUMERICHOST) != 0)
-			fatal("check_host_key: getnameinfo failed");
-		ip = xstrdup(ntop);
+		/* Will work for the IP address families only */
+		if ((hostaddr->sa_family == AF_INET) ||
+		    (hostaddr->sa_family == AF_INET6)) {
+			if (getnameinfo(hostaddr, salen, ntop, sizeof(ntop),
+		    	    NULL, 0, NI_NUMERICHOST) != 0)
+				fatal("check_host_key: getnameinfo failed");
+			ip = xstrdup(ntop);
+		/* Unix Domain Socket is local so we won't check IP */
+		} else if (hostaddr->sa_family == AF_UNIX) {
+			ip = xstrdup("<no hostip for unix domain socket>");
+		/* Unsupported address family */
+		} else {
+			fatal("check_host_key: can't get name info");
+		}
 	} else {
 		ip = xstrdup("<no hostip for proxy command>");
 	}
 	/*
 	 * Turn off check_host_ip if the connection is to localhost, via proxy
diff -N -U 5 -u openssh-4.2p1/sshconnect.h sshop-4.2p1/sshconnect.h
--- openssh-4.2p1/sshconnect.h	Thu Jun 20 20:41:53 2002
+++ sshop-4.2p1/sshconnect.h	Tue May  3 17:45:23 2005
@@ -34,10 +34,12 @@
 };
 
 int
 ssh_connect(const char *, struct sockaddr_storage *, u_short, int, int,
     int, const char *);
+int
+ssh_connect_uds(const char *, struct sockaddr_storage *);
 
 void
 ssh_login(Sensitive *, const char *, struct sockaddr *, struct passwd *);
 
 int	 verify_host_key(char *, struct sockaddr *, Key *);
diff -N -U 5 -u openssh-4.2p1/sshconnect1.c sshop-4.2p1/sshconnect1.c
--- openssh-4.2p1/sshconnect1.c	Thu Jun 16 22:59:35 2005
+++ sshop-4.2p1/sshconnect1.c	Fri Oct 21 16:02:31 2005
@@ -246,11 +246,11 @@
 		private = key_load_private_type(KEY_RSA1, authfile, "", NULL);
 	if (private == NULL && !options.batch_mode) {
 		snprintf(buf, sizeof(buf),
 		    "Enter passphrase for RSA key '%.100s': ", comment);
 		for (i = 0; i < options.number_of_password_prompts; i++) {
-			passphrase = read_passphrase(buf, 0);
+			passphrase = read_passphrase(buf, RP_ADD_ID);
 			if (strcmp(passphrase, "") != 0) {
 				private = key_load_private_type(KEY_RSA1,
 				    authfile, passphrase, NULL);
 				quit = 0;
 			} else {
@@ -404,11 +404,11 @@
 		if (i != 0)
 			error("Permission denied, please try again.");
 		if (options.cipher == SSH_CIPHER_NONE)
 			logit("WARNING: Encryption is disabled! "
 			    "Response will be transmitted in clear text.");
-		response = read_passphrase(prompt, 0);
+		response = read_passphrase(prompt, RP_ADD_ID);
 		if (strcmp(response, "") == 0) {
 			xfree(response);
 			break;
 		}
 		packet_start(SSH_CMSG_AUTH_TIS_RESPONSE);
@@ -441,11 +441,11 @@
 	if (options.cipher == SSH_CIPHER_NONE)
 		logit("WARNING: Encryption is disabled! Password will be transmitted in clear text.");
 	for (i = 0; i < options.number_of_password_prompts; i++) {
 		if (i != 0)
 			error("Permission denied, please try again.");
-		password = read_passphrase(prompt, 0);
+		password = read_passphrase(prompt, RP_ADD_ID);
 		packet_start(SSH_CMSG_AUTH_PASSWORD);
 		ssh_put_password(password);
 		memset(password, 0, strlen(password));
 		xfree(password);
 		packet_send();
